var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import React from 'react';
import { useId } from '@react-devui/hooks';
import { CheckCircleOutlined, CloseCircleOutlined, CloseOutlined, ExclamationCircleOutlined, WarningOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useTranslation } from '../root';
function Panel(props, ref) {
    const { dClassNamePrefix, dType, dIcon, dTitle, dDescription, dActions = ['close'], onClose } = props, restProps = __rest(props, ["dClassNamePrefix", "dType", "dIcon", "dTitle", "dDescription", "dActions", "onClose"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const prefix = `${dPrefix}${dClassNamePrefix}`;
    const [t] = useTranslation();
    const uniqueId = useId();
    const titleId = `${prefix}-title-${uniqueId}`;
    const contentId = `${prefix}-content-${uniqueId}`;
    return (_jsxs("div", Object.assign({}, restProps, { ref: ref, className: getClassName(restProps.className, prefix, {
            [`t-${dType === 'info' ? 'primary' : dType === 'error' ? 'danger' : dType}`]: dType,
        }), "aria-labelledby": titleId, "aria-describedby": contentId }, { children: [dIcon !== false && (!isUndefined(dType) || checkNodeExist(dIcon)) && (_jsx("div", Object.assign({ className: `${prefix}__icon` }, { children: checkNodeExist(dIcon)
                    ? dIcon
                    : React.createElement(dType === 'success'
                        ? CheckCircleOutlined
                        : dType === 'warning'
                            ? WarningOutlined
                            : dType === 'error'
                                ? CloseCircleOutlined
                                : ExclamationCircleOutlined) }))), _jsxs("div", Object.assign({ id: contentId, className: `${prefix}__content` }, { children: [_jsxs("div", Object.assign({ className: `${prefix}__header` }, { children: [_jsx("div", Object.assign({ id: titleId, className: `${prefix}__title` }, { children: dTitle })), _jsx("div", Object.assign({ className: `${prefix}__header-actions` }, { children: React.Children.map(dActions, (action) => action === 'close' ? (_jsx("button", Object.assign({ className: `${prefix}__close`, "aria-label": t('Close'), onClick: onClose }, { children: _jsx(CloseOutlined, { dSize: "1.2em" }) }), "$$close")) : (action)) }))] })), checkNodeExist(dDescription) && _jsx("div", Object.assign({ className: `${prefix}__description` }, { children: dDescription }))] }))] })));
}
export const DPanel = React.forwardRef(Panel);
