/// <reference types="react" />
export interface DStepperItem {
    step?: number;
    title: React.ReactNode;
    description?: React.ReactNode;
    icon?: React.ReactNode;
    status?: 'completed' | 'active' | 'wait' | 'error';
}
export interface DStepperProps<T extends DStepperItem> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dList: T[];
    dActive?: number;
    dPercent?: number;
    dVertical?: boolean;
    dIconSize?: number;
    dLabelBottom?: boolean;
    dClickable?: boolean;
    onItemClick?: (step: number, item: T) => void;
}
export declare function DStepper<T extends DStepperItem>(props: DStepperProps<T>): JSX.Element | null;
